;*****************************************
;*
;* CCIO.asm (Derzeit ist hier keine Version fuer den Assembler 'TASM' vorhanden.)
;* Kommando-Interpreter mit 9600 Baud
;*
;*****************************************
;opt c,l *Ports
portb equ $01 ;Daten Port B (Port1...8)
portc equ $02 ;Daten Port C (Port9...16)
pbdir equ $05 ;Datenrichtung Port B
pcdir equ $06 ;Datenrichtung Port C
;*Serielle Schnittstelle
brate equ $0D ;SCR-Baudrate
sccr1 equ $0E ;Controlregister 1
sccr2 equ $0F ;Contrllregister 2
scsr equ $10 ;Status-Register
scdat equ $11 ;Datenregister
;*AD-Wandler
addata equ $08 ;Datenregister
adstat equ $09 ;Status/Control
;*DA-Wandler
misc equ $0C ;Ausgaberate
plma equ $0A ;PLM A
plmb equ $0B ;PLM B
;*Variablenspeicher im RAM
Kom equ $0A1 ;Kommando
_ADC equ $0A2 ;AD-Kanal

    org $101 ;Startadresse om C-Control
init lda #$FF ;P1...P8 Ausgaenge
     sta pbdir
     lda #$00 ;P1...P8 = 0
     sta portb
     lda #$C0 ;19200 Baud
     sta brate
     lda #$00 ;Ohne Interrupts
     sta sccr1
     lda #$0C ;RxD und TxD freigeben
     sta sccr2
     lda #0 ;PLM-Kanaele schnell
     sta misc
Loop jsr RdCOM ;Kommando empfangen
     sta Kom ;empfangenes Kommando speichern
     lda #$01 ;Kommando 1: ID-Byte senden
     cmp Kom ;A=Kom?
     bne K16 ;nein: ueberspringen
     lda #$14 ;ID-Byte 20
     jsr WrCOM ;senden
K16  lda #$10 ;Kommando 16, Portausgabe
     cmp Kom ;A=Kom?
     bne K32 ;nein: ueberspringen
     jsr RdCOM ;empfangen
     sta portb ;Port B ausgeben
K32  lda #$20 ;Kommando 32, Porteingabe
     cmp Kom ;A=Kom?
     bne K48 ;nein: ueberspringen
     lda portc ;Port C lesen
     jsr WrCOM ;senden
K48  lda #$30 ;Kommando 48, Analog A
     cmp Kom ;A=Kom?
     bne K49 ;nein: ueberspringen
     lda #0 ;Kanal 0
     sta _ADC ;speichern
     jsr RdAD ;messen
     jsr WrCOM ;senden
K49  lda #$31 ;Kommando 49, Analog B
     cmp Kom ;A=Kom?
     bne K50 ;nein: ueberspringen
     lda #1 ;Kanal 1
     sta _ADC ;speichern
     jsr RdAD ;messen
     jsr WrCOM ;senden
K50  lda #$32 ;Kommando 50, Analog C
     cmp Kom ;A=Kom?
     bne K51 ;nein: ueberspringen
     lda #2 ;Kanal 2
     sta _ADC ;speichern
     jsr RdAD ;messen
     jsr WrCOM ;senden
K51  lda #$33 ;Kommando 50, Analog D
     cmp Kom ;A=Kom?
     bne K64 ;nein: ueberspringen
     lda #3 ;Kanal 3
     sta _ADC ;speichern
     jsr RdAD ;messen
     jsr WrCOM ;senden
K64  lda #$40 ;Kommando 64, PLM A
     cmp Kom ;A=Kom?
     bne K65 ;nein: ueberspringen
     jsr RdCOM ;empfangen
     sta plma
K65  lda #$41 ;Kommando 65, PLM B
     cmp Kom ;A=Kom?
     bne K100 ;nein: ueberspringen
     jsr RdCOM ;empfangen
     sta plmb
K100 bra Loop ;Endlosschleife

RdCOM brclr 5,scsr,RdCOM ;warten bis Empfang
      lda scdat ;Daten lesen
      rts

WrCOM brclr 7,scsr,WrCOM ;warten bis bereit
      sta scdat ;Daten schreiben
      rts

RdAD  lda #$20 ;AD-Wandler aktiv
      ADD _ADC ;plus Kanal
      sta adstat ;Wandlung starten
_Wait  brclr 7,adstat,_Wait ;warten bis fertig
      lda addata ;Ergebnis lesen
      rts
end